博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
Codeforces 220B - Little Elephant and Array 离线树状数组
阅读量:6428 次
发布时间:2019-06-23

本文共 3268 字,大约阅读时间需要 10 分钟。

This problem can be solve in simpler O(NsqrtN) solution, but I will describe O(NlogN) one.

We will solve this problem in offline. For each x (0 ≤ x < n) we should keep all the queries that end in x. Iterate that x from 0 to n - 1. Also we need to keep some array D such that for current x Dl + Dl + 1 + ... + Dx will be the answer for query [l;x]. To keep D correct, before the processing all queries that end in x, we need to update D. Let t be the current integer in A, i. e. Ax, and vector P be the list of indices of previous occurences of t (0-based numeration of vector). Then, if |P| ≥ t, you need to add 1 to DP[|P| - t], because this position is now the first (from right) that contains exactly t occurences of t. After that, if |P| > t, you need to subtract 2 from DP[|P| - t - 1], in order to close current interval and cancel previous. Finally, if |P| > t + 1, then you need additionally add 1 to DP[|P| - t - 2] to cancel previous close of the interval.

#include 
#include
#include
#include
#include
#include
#include
#include
#include
#include
using namespace std;#define ls(rt) rt*2#define rs(rt) rt*2+1#define ll long long#define ull unsigned long long#define rep(i,s,e) for(int i=s;i
0) { ret+=c[x]; x-=lowbit(x); } return ret;}int main(){ int sz; while(~scanf("%d%d",&n,&m)) { vector
data[MAXN]; CL(c,0); for(int i=1;i<=n;i++) scanf("%d",&a[i]); for(int i=1;i<=m;i++) { scanf("%d%d",&q[i].l,&q[i].r); q[i].id=i; } sort(q+1,q+1+m); for(int i=1,k=1;i<=n;i++) { if(a[i]<=n) { data[a[i]].push_back(i); sz=data[a[i]].size(); if(sz>=a[i]) { add(data[a[i]][sz-a[i]],1); if(sz>a[i])add(data[a[i]][sz-a[i]-1],-2); if(sz>a[i]+1)add(data[a[i]][sz-a[i]-2],1); } } while(q[k].r==i && k<=m) { ans[q[k].id]=sum(q[k].r)-sum(q[k].l-1); k++; } } for(int i=1;i<=m;i++) printf("%d\n",ans[i]); } return 0;}

用于调试理解的及及加了凝视的代码

#include 
#include
#include
#include
#include
#include
#include
#include
#include
#include
using namespace std;#define ls(rt) rt*2#define rs(rt) rt*2+1#define ll long long#define ull unsigned long long#define rep(i,s,e) for(int i=s;i
0) { ret+=c[x]; x-=lowbit(x); } return ret;}int main(){ int sz; while(~scanf("%d%d",&n,&m)) { vector
data[MAXN]; CL(c,0); for(int i=1;i<=n;i++) scanf("%d",&a[i]); for(int i=1;i<=m;i++) { scanf("%d%d",&q[i].l,&q[i].r); q[i].id=i; } sort(q+1,q+1+m); for(int i=1,k=1;i<=n;i++) { if(a[i]<=n) { data[a[i]].push_back(i); sz=data[a[i]].size(); if(sz>=a[i]) { add(data[a[i]][sz-a[i]],1);//从右往左第a[i]次出现a[i]的位置+1 if(sz>a[i])add(data[a[i]][sz-a[i]-1],-2); //从右往左第a[i]+1次出现a[i]的位置 -2, //由于当Sz==a[i]的时候,这个位置已经被加过1。此次读到i的时候。 //从右往左第a[i]次出现a[i]的位置也被+1。 //那么查询第a[i]+1次出现a[i]的位置到i。答案就是-2+1+1=0, //查询第a[i]次出现a[i]的位置到i,答案就是1 if(sz>a[i]+1)add(data[a[i]][sz-a[i]-2],1); //从右往左第a[i]+2次出现a[i]的位置 +1,之前被+1-2,所以变成0 //这三行代码维护出来,从当前的i往左数,第a[i]次出现a[i]的位置总是1 //第a[i]+1次出现a[i]的位置总是-1,第a[i]+2及很多其它次的位置总是0,这样以i为右端点的区间的查询结果就都对了 } } while(q[k].r==i && k<=m) { / printf("#i=%d#\n",i); for(int j=0;j<=n;j++) printf("c[%d]=%d\n",j,c[j]); // ans[q[k].id]=sum(q[k].r)-sum(q[k].l-1); k++; } } for(int i=1;i<=m;i++) printf("%d\n",ans[i]); } return 0;}

转载地址:http://hfnga.baihongyu.com/

你可能感兴趣的文章
Postman 网络调试工具
查看>>
Python教程6
查看>>
zabbix实现自动发现功能添加磁盘监控
查看>>
ext grid 前台grid加载数据碰到数据重复只显示一条
查看>>
Eclipse智能提示及快捷键
查看>>
在windows下安装php redis扩展
查看>>
PHP漏洞 (转)
查看>>
js获取iframe的id
查看>>
一个完整的WSDL文档及各标签详解
查看>>
mysql8.0.14 安装
查看>>
svn is already locked解决方案
查看>>
C++基础算法学习——猜假币
查看>>
1039. 到底买不买(20)
查看>>
JavaScript的块级作用域
查看>>
前端将markdown转换成html
查看>>
设计模式学习笔记之生成器模式
查看>>
jsp入门
查看>>
ORM之轻量级框架--Dapper
查看>>
自动化邮件报告平台-邮件发送highchart图表
查看>>
进程池的返回值
查看>>